<%@ page language="java" contentType="text/html; charset=ISO-8859-1" pageEncoding="ISO-8859-1"%>
<%--
  ~  Copyright (c) 2008, WSO2 Inc. (http://www.wso2.org) All Rights Reserved.
  ~
  ~  Licensed under the Apache License, Version 2.0 (the "License");
  ~  you may not use this file except in compliance with the License.
  ~  You may obtain a copy of the License at
  ~
  ~        http://www.apache.org/licenses/LICENSE-2.0
  ~
  ~  Unless required by applicable law or agreed to in writing, software
  ~  distributed under the License is distributed on an "AS IS" BASIS,
  ~  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
  ~  See the License for the specific language governing permissions and
  ~  limitations under the License.
  --%>

<%@ page import="org.wso2.carbon.sequences.common.to.SequenceInfo" %>
<%@ page import="org.wso2.carbon.sequences.ui.DelegatingSequenceAdminClient" %>
<%@ page import="org.wso2.carbon.ui.CarbonUIMessage" %>
<%@ page import="org.wso2.carbon.ui.CarbonUIUtil" %>
<%@ taglib prefix="fmt" uri="http://java.sun.com/jsp/jstl/fmt" %>
<%@ taglib uri="http://wso2.org/projects/carbon/taglibs/carbontags.jar" prefix="carbon" %>

<%
    DelegatingSequenceAdminClient sequenceAdminClient
            = new DelegatingSequenceAdminClient();
    SequenceInfo[] sequences = null;
    try {
        sequences = sequenceAdminClient.getSequences(this.getServletConfig(), session);
    } catch (Exception e) {
        CarbonUIMessage.sendCarbonUIMessage(e.getMessage(), CarbonUIMessage.ERROR, request, e);
%>
        <script type="text/javascript">
               location.href = "../admin/error.jsp";
        </script>
<%
        return;
    }
    String backendServerURL = CarbonUIUtil.getServerURL(config.getServletContext(), session);
    session.removeAttribute("mediator.position");
%>

<script type="text/javascript" src="../carbon/global-params.js"></script>

<fmt:bundle basename="org.wso2.carbon.sequences.ui.i18n.Resources">
<carbon:jsi18n
                resourceBundle="org.wso2.carbon.sequences.ui.i18n.JSResources"
                request="<%=request%>" />

<script type="text/javascript">

    wso2.wsf.Util.initURLs();
    var ENABLE = "enable";
    var DISABLE = "disable";
    var STAT = "statistics";
    var TRACE = "Tracing";

    var frondendURL = wso2.wsf.Util.getServerURL() + "/";

    function addSequence() {
        document.location.href = "design_sequence.jsp?sequenceAction=add";
    }

    function disableStat(sequenceName) {
        $.ajax({
            type: 'POST',
            url: 'stat_tracing-ajaxprocessor.jsp',
            data: 'sequenceName=' + sequenceName + '&action=disableStat',
            success: function(msg) {
                handleCallback(sequenceName, DISABLE, STAT);
            },
            error: function(msg) {
                CARBON.showErrorDialog('<fmt:message key="sequence.stat.disable.error"/>' +
                                       ' ' + sequenceName);
            }
        });
    }

    function enableStat(sequenceName) {
        $.ajax({
            type: 'POST',
            url: 'stat_tracing-ajaxprocessor.jsp',
            data: 'sequenceName=' + sequenceName + '&action=enableStat',
            success: function(msg) {
                handleCallback(sequenceName, ENABLE, STAT);
            },
            error: function(msg) {
                CARBON.showErrorDialog('<fmt:message key="sequence.stat.enable.error"/>' +
                                       ' ' + sequenceName);
            }
        });
    }

    function handleCallback(seq, action, type) {
        var element;
        if (action == "enable") {
            if (type == "statistics") {
                element = document.getElementById("disableStat" + seq);
                element.style.display = "";
                element = document.getElementById("enableStat" + seq);
                element.style.display = "none";
            } else {
                element = document.getElementById("disableTracing" + seq);
                element.style.display = "";
                element = document.getElementById("enableTracing" + seq);
                element.style.display = "none";
            }
        } else {
            if (type == "statistics") {
                element = document.getElementById("disableStat" + seq);
                element.style.display = "none";
                element = document.getElementById("enableStat" + seq);
                element.style.display = "";
            } else {
                element = document.getElementById("disableTracing" + seq);
                element.style.display = "none";
                element = document.getElementById("enableTracing" + seq);
                element.style.display = "";
            }
        }
    }

    function enableTracing(sequenceName) {
        $.ajax({
            type: 'POST',
            url: 'stat_tracing-ajaxprocessor.jsp',
            data: 'sequenceName=' + sequenceName + '&action=enableTracing',
            success: function(msg) {
                handleCallback(sequenceName, ENABLE, TRACE);
            },
            error: function(msg) {
                CARBON.showErrorDialog('<fmt:message key="sequence.trace.enable.link"/>' +
                                       ' ' + sequenceName);
            }
        });
    }

    function disableTracing(sequenceName) {
        $.ajax({
            type: 'POST',
            url: 'stat_tracing-ajaxprocessor.jsp',
            data: 'sequenceName=' + sequenceName + '&action=disableTracing',
            success: function(msg) {
                handleCallback(sequenceName, DISABLE, TRACE);
            },
            error: function(msg) {
                CARBON.showErrorDialog('<fmt:message key="sequence.trace.disable.error"/>' + 
                                       ' ' + sequenceName);
            }
        });
    }

    function editSequence() {
        document.location.href = "design_sequence.jsp?sequenceAction=edit&sequenceName=" + arguments[0];
    }

    function deleteSequence(sequenceName) {
        if (sequenceName == "main" || sequenceName == "fault") {
           CARBON.showWarningDialog('<fmt:message key="sequence.main.fault.cannot.delete"/>');
        } else {
            CARBON.showConfirmationDialog("<fmt:message key="sequence.delete.confirmation"/> " + sequenceName + "?", function(){
                location.href = "delete_sequence.jsp?sequenceName=" + sequenceName;
            });
        }
    }

    function getResponseValue(responseXML) {
        var returnElementList = responseXML.getElementsByTagName("ns:return");
        // Older browsers might not recognize namespaces (e.g. FF2)
        if (returnElementList.length == 0)
            returnElementList = responseXML.getElementsByTagName("return");
        var returnElement = returnElementList[0];

        return returnElement.firstChild.nodeValue;
    }

</script>

<style type="text/css">
    .inlineDiv div {
        float: left;
    }
</style>

    <carbon:breadcrumb
            label="sequence.menu.text"
            resourceBundle="org.wso2.carbon.sequences.ui.i18n.Resources"
            topPage="true"
            request="<%=request%>" />

    <div id="middle">

        <h2>
            <fmt:message key="mediation.sequences.header"/>
        </h2>

        <div id="workArea">
            <p><fmt:message key="sequences.defined.text"/></p>
            <br/>
            <table class="styledLeft" cellspacing="1" id="sequencesTable">
                <thead>
                    <tr>
                        <th>
                            <fmt:message key="sequence.name"/>
                        </th>
                        <th colspan="4">
                            <fmt:message key="sequence.actions"/>
                        </th>
                    </tr>
                </thead>
                <tbody>
                    <% for (SequenceInfo sequence : sequences) { %>
                    <tr>
                        <td>
                            <%= sequence.getName() %>
                        </td>
                                <% if (sequence.isEnableStatistics()) { %>
                                <td style="border-right:none;border-left:none;width:200px">
                                    <div class="inlineDiv">
                                <div id="disableStat<%= sequence.getName()%>">
                                    <a href="#" onclick="disableStat('<%= sequence.getName() %>')" class="icon-link" style="background-image:url(../admin/images/static-icon.gif);"><fmt:message key="sequence.stat.disable.link"/></a>
                                </div>
                                <div id="enableStat<%= sequence.getName()%>" style="display:none;">
                                    <a href="#" onclick="enableStat('<%= sequence.getName() %>')" class="icon-link" style="background-image:url(../admin/images/static-icon-disabled.gif);"><fmt:message key="sequence.stat.enable.link"/></a>
                                </div>
                                        </div>
                                    </td>
                                <% } else { %>
                                        <td style="border-right:none;border-left:none;width:200px">
                                    <div class="inlineDiv">
                                <div id="enableStat<%= sequence.getName()%>">
                                    <a href="#" onclick="enableStat('<%= sequence.getName() %>')" class="icon-link" style="background-image:url(../admin/images/static-icon-disabled.gif);"><fmt:message key="sequence.stat.enable.link"/></a>
                                </div>
                                <div id="disableStat<%= sequence.getName()%>" style="display:none">
                                    <a href="#" onclick="disableStat('<%= sequence.getName() %>')" class="icon-link" style="background-image:url(../admin/images/static-icon.gif);"><fmt:message key="sequence.stat.disable.link"/></a>
                                </div>
                                        </div>
                                    </td>
                                <% } %>
                                <% if (sequence.isEnableTracing()) { %>
                                        <td style="border-right:none;border-left:none;width:200px">
                                    <div class="inlineDiv">
                                <div id="disableTracing<%= sequence.getName()%>">
                                    <a href="#" onclick="disableTracing('<%= sequence.getName() %>')" class="icon-link" style="background-image:url(../admin/images/trace-icon.gif);"><fmt:message key="sequence.trace.disable.link"/></a>
                                </div>
                                <div id="enableTracing<%= sequence.getName()%>" style="display:none;">
                                    <a href="#" onclick="enableTracing('<%= sequence.getName() %>')" class="icon-link" style="background-image:url(../admin/images/trace-icon-disabled.gif);"><fmt:message key="sequence.trace.enable.link"/></a>
                                </div>
                                        </div>
                                    </td>
                                <% } else { %>
                                        <td style="border-right:none;border-left:none;width:200px">
                                    <div class="inlineDiv">
                                <div id="enableTracing<%= sequence.getName()%>">
                                    <a href="#" onclick="enableTracing('<%= sequence.getName() %>')" class="icon-link" style="background-image:url(../admin/images/trace-icon-disabled.gif);"><fmt:message key="sequence.trace.enable.link"/></a>
                                </div>
                                <div id="disableTracing<%= sequence.getName()%>" style="display:none">
                                    <a href="#" onclick="disableTracing('<%= sequence.getName() %>')" class="icon-link" style="background-image:url(../admin/images/trace-icon.gif);"><fmt:message key="sequence.trace.disable.link"/></a>
                                </div>
                                        </div>
                                    </td>
                                <% } %>
                                        <td style="border-left:none;border-right:none;width:100px">
                                    <div class="inlineDiv">
                                <a href="#" onclick="editSequence('<%= sequence.getName() %>')" class="icon-link" style="background-image:url(../admin/images/edit.gif);"><fmt:message key="sequence.edit.action"/></a>
                                        </div>
                                    </td>
                                        <td style="border-left:none;width:100px">
                                    <div class="inlineDiv">
                                <a href="#" onclick="deleteSequence('<%= sequence.getName() %>')" class="icon-link" style="background-image:url(../admin/images/delete.gif);"><fmt:message key="sequence.delete.action"/></a>
                                        </div>
                                    </td>
                    </tr>
                    <% } %>
                </tbody>
            </table>

            <script type="text/javascript">
                alternateTableRows('sequencesTable', 'tableEvenRow', 'tableOddRow');
            </script>

            <div style="height:25px;">
                <a class="icon-link" style="background-image: url(../admin/images/add.gif);" href="javascript:addSequence()"><fmt:message key="sequence.button.add.text"/></a>
            </div>

        </div>

        <%
            if (session.getAttribute("sequence.error.message") != null) {
        %>
        <script type="text/javascript">
            jQuery(document).ready(function() {
                CARBON.showErrorDialog("<%= session.getAttribute("sequence.error.message") %>");
            });
        </script>
        <%
                session.removeAttribute("sequence.error.message");
            }

            if (session.getAttribute("sequence.warn.message") != null) {
        %>
        <script type="text/javascript">
            jQuery(document).ready(function() {
                CARBON.showWarningDialog("<%= session.getAttribute("sequence.warn.message") %>");
            });
        </script>
        <%
                session.removeAttribute("sequence.warn.message");
            }
        %>
    </div>

</fmt:bundle>
